import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:endlich/endlich.dart';
import 'package:riverpod/riverpod.dart';
import 'package:riverpod_endlich/src/provider.dart';

import 'auto_dispose_provider.dart';

class MachineStateProviderFamilyBuilder {
  const MachineStateProviderFamilyBuilder();

  MachineStateProviderFamily<Machine, State, Arg>
      call<Machine extends StateMachine<State>, State, Arg>(
    FamilyCreate<Machine, ChangeNotifierProviderRef<Machine>, Arg> create, {
    String? name,
  }) {
    return MachineStateProviderFamily<Machine, State, Arg>(create, name: name);
  }
}

class AutoDisposeMachineStateProviderFamilyBuilder {
  const AutoDisposeMachineStateProviderFamilyBuilder();

  AutoDisposeMachineStateProviderFamily<Machine, State, Arg>
      call<Machine extends StateMachine<State>, State, Arg>(
    FamilyCreate<Machine, AutoDisposeChangeNotifierProviderRef<Machine>, Arg>
        create, {
    String? name,
  }) {
    return AutoDisposeMachineStateProviderFamily<Machine, State, Arg>(create,
        name: name);
  }
}

class AutoDisposeMachineStateProviderBuilder {
  const AutoDisposeMachineStateProviderBuilder();

  AutoDisposeMachineStateProvider<Machine, State>
      call<Machine extends StateMachine<State>, State>(
    Create<Machine, AutoDisposeChangeNotifierProviderRef<Machine>> create, {
    String? name,
  }) {
    return AutoDisposeMachineStateProvider<Machine, State>(create, name: name);
  }
}
